from Martel.formats.PIR_3_0 import *

import support

test_list = support.Storage()
add_test = test_list.add_test
add_test_lines = test_list.add_test_lines

s1="""\
 
                P R O T E I N  S E Q U E N C E  D A T A B A S E
                             of PIR-International
 
"""
s2="""\
                         Section 3. Unverified Entries
                   Release 65.00,  June 30, 2000,  09:46:55
                        666 sequences, 363722 residues
 
"""
s3="""\
                      Protein Information Resource (PIR)*
                    National Biomedical Research Foundation
                          3900 Reservoir Road, N.W.,
                          Washington, DC  20007, USA
 
   Japan International Protein           Munich Information Center for
   Information Database (JIPID)             Protein Sequences (MIPS)
         Amakubo 1-16-1          GSF-Forschungszentrum f. Umwelt und Gesundheit
    Tsukuba 305-0005, Japan            am Max-Planck-Instut f. Biochemie
                                  Am Klopferspitz 18, D-82152 Martinsried, FRG
 
 
"""
s4="""\
   This database may be redistributed without prior consent, provided that
   this notice be given to each user and that the words "Derived from" shall
   precede this notice if the database has been altered by the redistributor.
 
                       *PIR is a registered mark of NBRF.
 
 
\\\
"""
add_test("header1", header1, s1)
add_test("header2", header2, s2)
add_test("header3", header3, s3)
add_test("header4", header4, s4)
add_test("header", header, s1+s2+s3+s4)

del s1, s2, s3, s4

add_test_lines("entry", entry, """\
ENTRY            JC7119     #type complete
ENTRY            PC7076     #type fragment
ENTRY            T42219     #type complete
""")

add_test("title 1", title, """\
TITLE            probable transposase - Streptomyces coelicolor (fragment)
""")
add_test("title 2", title, """\
TITLE            probable IS element ATP-binding protein - Streptomyces
                   coelicolor (fragment)
""")
add_test("title 3", title, """\
TITLE            probable lipid metabolism protein, sphingomyelinase family
                   similarity - fission yeast (Schizosaccharomyces pombe)
                   (fragment)
""")

add_test("organism 1", organism, """\
ORGANISM         #formal_name Antirrhinum majus #common_name garden snapdragon
""")

add_test("organism 2", organism, """\
ORGANISM         #formal_name mitochondrion Colobus guereza #common_name
                   guereza
""")

add_test("organism 3", organism, """\
ORGANISM         #formal_name mitochondrion Pygathrix roxellana
""")

add_test("organism 4", organism, """\
ORGANISM         #formal_name mitochondrion Pygathrix roxellana
""")

add_test("organism 5", organism, """\
ORGANISM         #formal_name Oscheius sp. PS1131
""")
add_test("organism 6", organism, """\
ORGANISM         #formal_name murine endogenous retrovirus ERV-L
""")
add_test("organism 7", organism, """\
ORGANISM         #formal_name Cryphonectria parasitica, Endothia parasitica
                   #common_name chestnut blight fungus
""")
add_test("organism", organism, """\
ORGANISM         #formal_name Cryphonectria parasitica, Endothia parasitica,
                   Made Up
""")

add_test("date 1", date, """\
DATE             23-Oct-1999 #sequence_revision 23-Oct-1999 #text_change
                   23-Oct-1999
""")

add_test("date 2", date, """\
DATE             01-Oct-1999 #sequence_revision 12-Jan-1999 #text_change
                   23-Dec-2000
""")

add_test("accessions 1", accessions, """\
ACCESSIONS       T31338
""")

add_test("accessions 2", accessions, """\
ACCESSIONS       T31338; T3133; T313; T31; T3; T
""")


add_test("reference_number", reference_number, """\
REFERENCE        Z18677
""")

add_test("#authors 1", reference_authors, """\
   #authors      Olmstead, R.G.; Reeves, P.A.
""")

add_test("#authors 2", reference_authors, """\
   #authors      Sakai, J.; Rawson, R.B.; Espenshade, P.J.; Cheng, D.;
                   Seegmiller, A.C.; Goldstein, J.L.; Brown, M.S.
""")

add_test("#authors 3", reference_authors, """\
   #authors      Van Wageningen, A.; Kirkpatrick, P.; Williams, D.; Harris,
                   B.; Kershaw, J.; Lennard, N.; Jones, M.; Jones, S.;
                   Solenberg, P.
""")

add_test_lines("#journal", journal_subitem, """\
   #journal      Chem Biol (1998) 3:155-162
   #journal      Mol. Biol. Evol. (1996) 13:1351-1362
   #journal      Mol. Biol. Evol. (1996) 13:1351-1362
""")

add_test("#title 1", title_subitem, """\
   #title        Activity and substrate specificity of the murine STK2 serine=
""")
add_test("#title 2", title_subitem, """\
   #title        Akt phosphorylation site found in human caspase-9 is absent
                   in mouse caspase-9.
""")
add_test("#title 3", title_subitem, """\
   #title        Expression of the eicosapentaenoic acid synthesis gene
                   cluster from Shewanella sp. in a transgenic marine
                   cyanobacterium, Synechococcus sp.
""")

# Yes, the first date really is in PIR.
add_test_lines("#submission", submission_subitem, """\
   #submission   submitted to the EMBL Data Library, January 1299
   #submission   submitted to the EMBL Data Library, November 1996
   #submission   submitted to the Protein Sequence Database, July 1999
""")

add_test("#description 1", description_subitem, """\
   #description  Nucleotide sequences of the fap1 locus.
""")
add_test("#description 2", description_subitem, """\
   #description  Sequence analysis of a 3.5 Mb contig in human 19p13.3
                   containing a serine protease gene cluster.
""")
add_test("#description 3", description_subitem, """\
   #description  Identification and preliminary characterization of an nusual
                   leuciune-rich repeat receptor-like protein kinase from
                   morning glory (Ipomoea nil).
""")


add_test("xref subitem (medline) ", xref_subitem, """\
   #cross-references MUID:20012730
""")

add_test("accession_start", accession_start, """\
   #accession    T17467
""")
add_test("accession_status", accession_status, """\
      ##status        preliminary
""")
add_test("accession_residues 1", accession_residues, """\
      ##residues      1-2120 ##label COU
""")
# I'm guessing as to a valid format definition here
add_test("accession_residues 2", accession_residues, """\
      ##residues      1-2120,2140-2150,
                        89-322 ##label COU
""")

add_test("accession_xrefs 1", accession_xrefs, """\
      ##cross-references DDBJ:AB030228
""")

add_test("accession_xrefs 2", accession_xrefs, """\
      ##cross-references EMBL:AJ012287; NID:e1361091; PID:e1361092;
                         PIDN:CAA09979.1
""")
add_test("accession_xrefs 3", accession_xrefs, """\
      ##cross-references EMBL:AJ012287; NID:e1361091; PID:e1361092;
                         PIDN:CAA09979.1; PIDN:CAA09979.2; PIDN:CAA09979.3;
                         PIDN:CAA09979.4; PIDN:CAA09979.5
""")



add_test("summary 1", summary, """\
SUMMARY          #length 107  #checksum 2914
""")
add_test("summary 2", summary, """\
SUMMARY          #length 68  #molecular-weight 7292  #checksum 9557
""")

add_test("sequence 1", sequence, """\
SEQUENCE
                 5        10        15        20        25        30
       1/P Q A S R F L F K Q N R V R M I V D C H A T P V R V F Q D E
      31 A L M Q P L C L V G S T L R A P H G C H A Q Y M E N M G S I
      61 A S L T L A V I I N G N D E D G V G G R N S M R L W G L V V
      91 G H H T S A R C I P L P L R Y A C/
""")

add_test("sequence 2", sequence, """\
SEQUENCE
                 5        10
       1 W S G G G E F/I M H P
""")


add_test("record", record, """\
ENTRY            PQ0704     #type fragment
TITLE            Acyl-CoA oxidase (EC 1.3.3.6) - Rice (fragment)
ORGANISM         #formal_name Oryza sativa #common_name rice
DATE             03-Sep-1998 #sequence_revision 03-Sep-1998 #text_change
                   03-Sep-1998
ACCESSIONS       PQ0704
REFERENCE        PQ0696
   #authors      Komatsu, S.; Kajiwara, H.; Hirano, H.
   #journal      Theor. Appl. Genet. (1993) 86:935-942
   #title        A rice protein library; a data-file of rice proteins
                   separated by two-dimensional electrophoresis.
   #accession    PQ0704
      ##status        preliminary
      ##residues      1-62 ##label KOM
SUMMARY          #length 62  #checksum 5191
SEQUENCE
                 5        10        15        20        25        30
       1 P G L T I G D I V P N L G L D/L A A M A G Y A K E F D K R G
      31 V K L L G K H/A I K Q L N M V D P E K D S N/M G L T I G D T
      61 V X
///
""")

s1 = """\
ENTRY            JC7119     #type complete
TITLE            Drp35 protein - Staphylococcus aureus
ORGANISM         #formal_name Staphylococcus aureus
DATE             11-Dec-1999 #sequence_revision 11-Dec-1999 #text_change
                   11-Dec-1999
ACCESSIONS       JC7119
REFERENCE        JC7119
   #authors      Murakami, H.; Matsumaru, H.; Kanamori, M.; Hayashi, H.; Ohta,
                   T.
   #journal      Biochem. Biophys. Res. Commun. (1999) 264:348-351
   #title        Cell wall-affecting antibiotics induce expression of a novel
                   gene, drp35, in Staphylococcus aureus.
   #cross-references MUID:20001923
   #accession    JC7119
      ##status        preliminary
      ##residues      1-324 ##label MUR
      ##cross-references DDBJ:AB030228
SUMMARY          #length 324  #molecular-weight 35977  #checksum 9429
SEQUENCE
                 5        10        15        20        25        30
       1 M M S Q Q D L P T L F Y S G K S N S A V P I I S E S E L Q T
      31 I T A E P W L E I S K K G L Q L E G L N F D R Q G Q L F L L
      61 D V F E G N I F K I N P E T K E I K R P F V S H K A N P A A
      91 I K I H K D G R L F V C Y L G D F K S T G G I F A A T E N G
     121 D N L Q D I I E D L S T A Y C I D D M V F D S K G G F Y F T
     151 D F R G Y S T N P L G G V Y Y V S P D F R T V T P I I Q N I
     181 S V A N G I A L S T D E K V L W V T E T T A K R L H R I A L
     211 E D D G V T I Q P F G A T I P Y Y F T G H E G P D S C C I D
     241 S D D N L Y V A M Y G Q G R V L V F N K R G Y P I G Q I L I
     271 P G R D E G H M L R S T H P Q F I P G T N Q L I I C S N D I
     301 E M G G G S M L Y T V N G F A K G H Q S F Q F Q
///
"""
add_test("record 2", record, s1)

def test():
    test_list.test()

def dump():
    test_list.dump()

# Parsing pir3.dat (1.4MB and 666 records) takes 32 seconds
# With only the "id" callback, takes 24 seconds
# With no callback handler, only 8.5 seconds.
# ==> Most of the time spent in callbacks (the sequence data
#      is a call per character!)

def test_file(infile):
    import string, Martel
    parser = record.make_parser()
    #parser = Martel.select_names(record, ["id"]).make_parser()
    good = support.CheckGood()
    good.good_parse = 1
    #parser.setContentHandler(good)
    while 1:
        line = infile.readline()
        assert line, "where is the end of the header?"
        if line == "\\\\\\\n":
            break
    while 1:
        s = ""
        while 1:
            line = infile.readline()
            assert line, "early termination"
            if line == "\\\\\\\n" or line == "":
                assert s == "", "not empty string"
                return
            s = s + line
            if line == "///\n":
                parser.parseString(s)
                x = string.split(s, "\n")[0]
                if not good.good_parse:
                    print "Bad at", x
                    parser.setContentHandler(support.Dump())
                    parser.parseString(s)
                    1/0
                else:
                    print "Good at", x
                s = ""
                
            
